/*
If you don't want to require JGMOD, then uncomment the NO_JGMOD #define.
Ditto AASTR.

SLOW_SPRITE disables the optimized version of some mask-based functions in
msprite which may have issues.

NO_ALLEGRO_4 is for use with Allegro 3.12 and earlier... which isn't
portable, and doesn't work with recent versions of JGMOD... only for use
as a last resort.

OVERSIZE_BOXES is the number of extra pixels to expand boxes over what 
they should be.  Set to 0, this produces ordinary code... set to 1 it 
can fix the "streaking" problem that we have with some Allegro WIPs.  

*/

//#define   NO_JGMOD
//#define   NO_AASTR
//#define   SLOW_SPRITE
//#define   NO_ALLEGRO_4
//#define   FORCE_REDRAW

//#define   NETWORK_BSD_TCP
//#define   NETWORK_WINSOCK_TCP
#define   NETWORK_NONE


#define   GFX_TIMEWARP   GFX_AUTODETECT
//#define   GFX_TIMEWARP   GFX_DIRECTX_SOFT
//#define   GFX_TIMEWARP   GFX_DIRECTX_ACCEL
//#define   GFX_TIMEWARP   GFX_DIRECTX_SAFE
//#define   GFX_TIMEWARP   GFX_DIRECTX_WIN
//#define   GFX_TIMEWARP   GFX_GDI
//#define   GFX_TIMEWARP   GFX_SAFE
//#define   GFX_TIMEWARP   GFX_DIRECTX_OVL

#define   OVERSIZE_BOXES 1

#define   OVERRIDE_PATH "blah/"

#define   DEATH_FRAMES 13

/*
Don't change anything after this line
*/















#ifdef NO_ALLEGRO_4
  #define acquire_screen()
  #define release_screen()
  #define set_keyboard_rate(a,b)
  #define END_OF_MAIN()
  #define LOCK_VARIABLE(a)
  #define LOCK_FUNCTION(a)
  #define poll_keyboard()
  #define KEY_MAX 128
  #define allegro_message printf
#endif

#ifdef NO_AASTR
  #define aa_stretch_sprite stretch_sprite
#else
  #include <aastr.h>
#endif

#ifdef NO_JGMOD
  #define set_mod_volume(a)
  #define play_mod(a,b)
  #define stop_mod()
  #define is_mod_playing() 0
  #define remove_mod()
  #define install_mod(a)
  #define pause_mod()
  #define resume_mod()
#else
  #include <jgmod.h>
#endif
