#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <allegro.h>


#include "melee.h"
#include "libs.h"
#include "scp.h"

#include "melee/mview.h"
#include "melee/mcontrol.h"
#include "melee/mnet.h"
#include "melee/mmain.h"


#define SCPGUI_MUSIC   0
#define SCPGUI_TITLE   1

#define MAIN_DIALOG_MELEE    0
#define MAIN_DIALOG_TEAMS    1
#define MAIN_DIALOG_OPTIONS  2
#define MAIN_DIALOG_EXIT     3

#define FLEET_DIALOG_FLEETTITLE    0
#define FLEET_DIALOG_FLEETLIST     1
#define FLEET_DIALOG_SHIPLIST      2
#define FLEET_DIALOG_SELECT        3
#define FLEET_DIALOG_CLEAR         4
#define FLEET_DIALOG_PLAYERBOX     5
#define FLEET_DIALOG_PLAYERTEXT    6
#define FLEET_DIALOG_SAVE          7
#define FLEET_DIALOG_LOAD          8
#define FLEET_DIALOG_TITLE         9
#define FLEET_DIALOG_MAIN          10

#define TITLE_DIALOG_BOX    0
#define TITLE_DIALOG_EDIT   1
#define TITLE_DIALOG_OK     2
#define TITLE_DIALOG_CANCEL 3

int compatible_soundcard = FALSE;
int gamma_correction = 0;
int sound_volume = 255;
int music_volume = 255;
int sound_on = true;
int music_on = true;

DATAFILE *scp;

FILE *debug_file;

void showTitle();
void change_options();
void change_teams();
void init_video();
void init_sound();
void init_modem();
void init_gamma();
void (*tw_draw_rle_sprite)(BITMAP *bmp, RLE_SPRITE *sprite, int x, int y);

int update_gamma(void *dp3, int val);
int  getKey();

DIALOG mainDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_button_proc,     450,  50,   120,  40,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Melee" , NULL, NULL },
  { d_button_proc,     450,  100,  120,  40,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Teams" , NULL, NULL },
  { d_button_proc,     450,  150,  120,  40,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Options", NULL, NULL },
  { d_button_proc,     450,  200,  120,  40,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Exit", NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

char fleetPlayer[18];
char fleetTitleString[100];

DIALOG fleetDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_textbox_proc,    10,   5,    160,  48,   255,  0,    0,    0,       0,    0,    fleetTitleString, NULL, NULL },
  { d_list_proc,       10,   60,   160,  415,  255,  0,    0,    D_EXIT,  0,    0,    fleetListboxGetter, NULL, NULL },
  { d_list_proc,       470,  5,    160,  350,  255,  0,    0,    D_EXIT,  0,    0,    shipListboxGetter, NULL, NULL },
  { d_button_proc,     470,  365,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Select Ship", NULL, NULL },
  { d_button_proc,     470,  425,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Clear Slot", NULL, NULL },
  { d_box_proc,        240,  5,    160,  20,   255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_ctext_proc,      320,  10,   160,  10,   255,  0,    0,    0,       0,    0,    fleetPlayer, NULL, NULL },
  { d_button_proc,     240,  35,   160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Save Fleet", NULL, NULL },
  { d_button_proc,     240,  95,   160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Load Fleet", NULL, NULL },
  { d_button_proc,     240,  155,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Fleet Title", NULL, NULL },
  { d_button_proc,     240,  215,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Main", NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

char title_str[80];

DIALOG titleDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_box_proc,        180,  210,  280,  60,   255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_edit_proc,       190,  220,  260,  10,   255,  0,    0,    0,       80,   0,    title_str, NULL, NULL },
  { d_button_proc,     255,  240,  60,   18,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"OK", NULL, NULL },
  { d_button_proc,     325,  240,  60,   18,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Cancel", NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

char dialog_string[20][80];

#define MAX_PLAYERS 8
#define MAX_CONFIGURATIONS 4
char *playerListboxGetter(int index, int *list_size) ;
char *controlListboxGetter(int index, int *list_size) ;
char *viewListboxGetter(int index, int *list_size) ;

#define TEAMS_DIALOG_TITLE						0
#define TEAMS_DIALOG_PLAYERLIST				1
#define TEAMS_DIALOG_CONTROLLIST			2
#define TEAMS_DIALOG_SELECTCONTROL		3
#define TEAMS_DIALOG_CONFIG_NUM				4
#define TEAMS_DIALOG_SETUP						5
#define TEAMS_DIALOG_FLEET						6
#define TEAMS_DIALOG_MAINMENU					7

DIALOG teamsDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_textbox_proc,    250,  30,   120,  32,   255,  0,    0,    0,       0,    0,    (void *) "Teams Dialog", NULL, NULL },
  { d_list_proc,       10,   70,   160,  120,  255,  0,    0,    D_EXIT,  0,    0,    playerListboxGetter, NULL, NULL },
  { d_list_proc,       470,  70,   160,  120,  255,  0,    0,    D_EXIT,  0,    0,    controlListboxGetter, NULL, NULL },
  { d_button_proc,     240,  70,   160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Select Controller", NULL, NULL },
  { d_button_proc,     240,  130,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *) dialog_string[0], NULL, NULL },
  { d_button_proc,     240,  190,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *) "Edit Configuration", NULL, NULL },
  { d_button_proc,     240,  250,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *) "Edit Fleet", NULL, NULL },
  { d_button_proc,     240,  310,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Main Menu", NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};


char remark[80];

FONT *desktop_font;

////////////////// draw sprite without 'Gamma factor' ////////////////
void tw_draw_rle_sprite_nogamma (BITMAP *bmp, RLE_SPRITE *sprite, int x, int y)
{
  draw_rle_sprite(bmp, sprite,x, y);
}

///////////////// draw sprite with 'Gamma factor' ///////////////////
void tw_draw_rle_sprite_gamma(BITMAP *bmp, RLE_SPRITE *sprite, int x, int y)
{
  draw_lit_rle_sprite(bmp, sprite,x, y, gamma_correction);
}

void tw_draw_sprite(BITMAP *bmp, BITMAP *sprite, int x, int y)
{
  draw_lit_sprite (bmp, sprite, x, y, gamma_correction);
}

////  variables
  int    mainRet = 0, shipRet = 0, keyRet = 0, fleetRet = 0, optionsRet= 0;
  int    color_depth = 16;

char old_path[256];

void help() {
	char exn[256];
	char buffy[1024];
	buffy[0] = 0;
	get_executable_name(exn, 255);
	sprintf (buffy, "%s\n%s listen port\n%s connect address port\n", exn, exn, exn);
	tw_error(buffy);
	}

int player_type[MAX_PLAYERS];
int player_config[MAX_PLAYERS];

Control *load_player(int i) {
	char tmp[32];
	Control *r = NULL;
	sprintf (tmp, "Config%d", player_config[i]);
	r = getController(player_type[i], tmp);
	if (r) r->load("scp.ini", tmp);
	return r;
	}

int main(int argc, char *argv[]) {
  int    mainLoop;
	int i;

  allegro_init();
  install_timer();
  install_keyboard();
  install_mouse();

  int play_mode = 0;

	char *arg_addr = NULL;
	int arg_port = 0;
  for (i = 0; i < argc; i += 1) {
    if (!strcmp(argv[i], "listen")) {
			if (i+1 >= argc) help();
			arg_port = atoi(argv[i+1]);
			if (arg_port < 1024) help();
      play_mode = 2;
      net_start(arg_port);
      net_listen ();
			net_chat ();
      }
    if (!strcmp(argv[i], "connect")) {
			if (i+2 >= argc) help();
			arg_port = atoi(argv[i+2]);
			if (arg_port < 1024) help();
      play_mode = 3;
			arg_addr = argv[i+1];
      net_start(0);
      net_connect( arg_addr, arg_port );
			net_chat();
      }
		}

	replace_filename(old_path, argv[0], "", 255);
	chdir(OVERRIDE_PATH);
  
  srandom(time(NULL));
//	srandom(492159);

  set_keyboard_rate(0,0);

  #ifdef SCP_DEBUG
  debug_file = fopen("SCP.LOG", "w");
  #endif

  set_config_file("scp.ini");

  color_depth      = get_config_int("SCP", "BitsPerPixel", 16);
  gamma_correction = get_config_int("SCP", "Gamma", 0);
  antia_on         = get_config_int("SCP", "Anti-Aliasing", 1);
	set_view(view2number(get_config_string("SCP", "View", NULL)));

  init_sound();
  init_video();
	init_ships();
  init_fleet();

	set_config_file ("scp.ini");
	for (i = 0; i < MAX_PLAYERS; i += 1) {
		char tmp[32];
		sprintf (tmp, "Player%d", i+1);
		player_type[i] = control2number(get_config_string(tmp, "Type", "Keyboard"));
		player_config[i] = get_config_int (tmp, "Config", i % MAX_CONFIGURATIONS);
		}
	
  desktop_font = font;

  do {
    mainLoop = TRUE;

    install_keyboard();
    install_mouse();

    set_pallete((RGB*)(scppal[SCPPAL_PALLETE].dat));
    gui_fg_color = pallete_color[0];
    gui_bg_color = pallete_color[15];
    set_dialog_color(mainDialog, pallete_color[0], pallete_color[15]);
    set_dialog_color(fleetDialog, pallete_color[0], pallete_color[15]);
    set_dialog_color(titleDialog, pallete_color[0], pallete_color[15]);
    set_dialog_color(teamsDialog, pallete_color[0], pallete_color[15]);

    font = (FONT *)(scppal[SCPPAL_FONT].dat);
    play_mod((JGMOD *)(scp[SCPGUI_MUSIC].dat), TRUE);

    remark[0] = '\0';

    do {
      showTitle();
      mainRet = do_dialog(mainDialog, MAIN_DIALOG_MELEE);

      if(mainRet == MAIN_DIALOG_MELEE) {
        mainLoop = FALSE;
				} 
			else if(mainRet == MAIN_DIALOG_OPTIONS) {
				showTitle();
				change_options();
				}
			else if(mainRet == MAIN_DIALOG_TEAMS) change_teams();
    } while((mainLoop) && (mainRet != MAIN_DIALOG_EXIT) && (mainRet != -1));

    stop_mod();

    unload_datafile(scp);


    if(mainRet == MAIN_DIALOG_MELEE) {
			int i;
      font = desktop_font;
      acquire_screen();
      clear(screen);
      release_screen();
			Control *player[MAX_PLAYERS];
			int num_active = 0;
			for (i = 0; i < MAX_PLAYERS; i += 1) {
				if ((player[num_active] = load_player(i))) num_active += 1;
				}
      play_melee(play_mode, num_active, player);
			for (i = 0; i < num_active; i += 1) {
				if (player[i]) delete player[i];
				}
      font = (FONT *)(scppal[SCPPAL_FONT].dat);
			}

   scp = load_datafile("scpgui.dat"); //loading all data again

  } while((mainRet != MAIN_DIALOG_EXIT) && (mainRet != -1));

  remove_mod();
  remove_sound();
  remove_keyboard();
  remove_mouse();
  remove_timer();

  unload_datafile(scppal);

  allegro_exit();

	chdir(old_path);
  return 0;
}
END_OF_MAIN();

void showTitle() {
  acquire_screen();
  blit((BITMAP *)(scp[SCPGUI_TITLE].dat), screen, 0, 0, 0, 0, 640, 480);
  release_screen();
  if(remark[0] != '\0') {
    acquire_screen();
    textout_centre(screen, font, remark, 230, 230, pallete_color[15]);
    release_screen();
    remark[0] = '\0';
  }
}

void tw_error(char* message) {
  allegro_message("Error: %s\n", message);
#ifdef _WIN32
//  MessageBox(win_get_window(), message, "Star CoNETrol", MB_ICONSTOP);
#else
//  allegro_message("Error: %s\n", message);
//  allegro_message("possibly: %d: %s\n", errno, strerror(errno));
  clear_keybuf();
  while (!keypressed()) ;
#endif
	net_end();
  allegro_exit();
	chdir(old_path);
  exit(42);
}

int getKey() {
//  #ifdef _WIN32
//    while(1)
//      for(int i = 0; i < KEY_MAX; i++)
//        if(key[i] != 0) {
//		  return i;
//		}
//  #else
    unsigned i;
    

    while(!keypressed()) poll_keyboard();

    i = 0;
    while((!key[i]) && (i < KEY_MAX)) i++;

    while(keypressed()) poll_keyboard();
  

    return(i);
//  #endif
}



//////////// Initializing gamma /////////////
void init_gamma()
{
//  tw_draw_rle_sprite = &tw_draw_rle_sprite_nogamma;
  tw_draw_rle_sprite=&tw_draw_rle_sprite_gamma;
  set_trans_blender(255, 255, 255, 0);
/*  RGB *pal = (RGB*)scppal[SCPPAL_PALLETE].dat;
  int scale = 100 + gamma_correction;
  for (int i = 0; i < 256; i += 1) {
    int tmp;
    tmp = int((pal[i].r+1) * scale / 101);
    if (tmp > 63) tmp = 63;
    pal[i].r = tmp;
    tmp = int((pal[i].g+1) * scale / 101);
    if (tmp > 63) tmp = 63;
    pal[i].g = tmp;
    tmp = int((pal[i].b+1) * scale / 101);
    if (tmp > 63) tmp = 63;
    pal[i].b = tmp;
  }
  set_pallete(pal);*/
}

//////////// Initializing video /////////////
void init_video()
{
  if((color_depth != 8) && (color_depth != 15)) color_depth = 16;

  set_color_depth(color_depth);
  if (set_gfx_mode(GFX_TIMEWARP, 640, 480, 0, 0)) {
		char buffy[200];
		sprintf (buffy, "Error switching to graphics mode: %s", allegro_error);
		tw_error(buffy);
		}

  scppal = load_datafile("scppal.dat");
  if(!scppal) tw_error("Error loading SCP pallete data\n");

  init_gamma();
  acquire_screen();
  clear(screen);
  release_screen();

//  set_pallete((RGB*)(scppal[SCPPAL_PALLETE].dat));
  set_dialog_color(mainDialog, pallete_color[0], pallete_color[15]);
  set_dialog_color(fleetDialog, pallete_color[0], pallete_color[15]);
  set_dialog_color(titleDialog, pallete_color[0], pallete_color[15]);

  scp = load_datafile("scpgui.dat");
  if(!scp) tw_error("Error loading SCP GUI data\n");

}

//////////// Initializing sound /////////////
void init_sound() {
	set_config_file("scp.ini");
	sound_volume = get_config_int("SCP", "SoundVolume", sound_volume);
	music_volume = get_config_int("SCP", "MusicVolume", music_volume);
	sound_on = get_config_int("SCP", "SoundOn", sound_on);
	music_on = get_config_int("SCP", "MusicOn", music_on);
	compatible_soundcard = FALSE;
	if (detect_digi_driver(DIGI_AUTODETECT)>=32) {
		compatible_soundcard=true;
		reserve_voices(32, -1);
		if (install_sound(DIGI_AUTODETECT, MIDI_NONE, "")<0) compatible_soundcard=FALSE;
		install_mod(16);
		}
	set_volumes();
	return;
	}


//////////// "Options Dialog" /////////////

#define OPTIONS_DIALOG_BOX					0
#define OPTIONS_DIALOG_GAMMATEXT		1
#define OPTIONS_DIALOG_GAMMA				2
#define OPTIONS_DIALOG_SOUND				3
#define OPTIONS_DIALOG_SOUND_SLIDER	4
#define OPTIONS_DIALOG_MUSIC				5
#define OPTIONS_DIALOG_MUSIC_SLIDER	6
#define OPTIONS_DIALOG_COLORTEXT		7
#define OPTIONS_DIALOG_8bit					8
#define OPTIONS_DIALOG_15bit				9
#define OPTIONS_DIALOG_16bit				10	
#define OPTIONS_DIALOG_AA						11
#define OPTIONS_DIALOG_VIEW_TEXT		12
#define OPTIONS_DIALOG_VIEW					13
#define OPTIONS_DIALOG_OK						14
#define OPTIONS_DIALOG_CANCEL				15
DIALOG optionsDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg) (bg) (key) (flags)  (d1)  (d2)  (dp)
  { d_box_proc,        50,   50,  360, 240,   255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_text_proc,       70,   80,   80,  15,   255,  0,    0,    0,       0,    0,    (void *)"Gamma Correction", NULL, NULL },
  { d_slider_proc,     170,  80,  200,  10,   255,  0,    0,    0,       255,  0,    NULL, NULL, NULL },
  { d_check_proc,      70,  110,  100,  15,   255,  0,    0,    0,       0,    0,    (void *)"Sound Volume", NULL, NULL },  
  { d_slider_proc,     170, 110,  200,  10,   255,  0,    0,    0,       255,  0,    NULL, NULL, NULL },
  { d_check_proc,      70,  140,  100,  15,   255,  0,    0,    0,       0,    0,    (void *)"Music Volume", NULL, NULL },  
  { d_slider_proc,     170, 140,  200,  10,   255,  0,    0,    0,       255,  0,    NULL, NULL, NULL },
  { d_text_proc,       70,  175+50,  325,  10,   255,  0,    0,    0,       0,    0,    (void *)"Color Depth", NULL, NULL },
  { d_radio_proc,      70,  190+50,   55,  10,   255,  0,    0,    0,       1,    0,    (void *)"8 bit" , NULL, NULL },
  { d_radio_proc,      70,  200+50,   55,  10,   255,  0,    0,    0,       1,    0,    (void *)"15 bit" , NULL, NULL },
  { d_radio_proc,      70,  210+50,   55,  10,   255,  0,    0,    0,       1,    0,    (void *)"16 bit" , NULL, NULL },
  { d_check_proc,      82,  195,  100,  15,   255,  0,    0,    0,       0,    0,    (void *)"Antialiasing", NULL, NULL },
  { d_text_proc,       224, 180,   80,  15,   255,  0,    0,    0,       0,    0,    (void *)"View", NULL, NULL },
  { d_list_proc,       220, 192,  100,  80,   255,  0,    0,    0,       0,    0,    viewListboxGetter, NULL, NULL },
  { d_button_proc,     470, 100,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"OK", NULL, NULL },
  { d_button_proc,     470, 160,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Cancel", NULL, NULL },
  { NULL,              0,   0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
	};

void set_radio_color(int val)
{
 optionsDialog[OPTIONS_DIALOG_8bit].flags=0;
 optionsDialog[OPTIONS_DIALOG_15bit].flags=0;
 optionsDialog[OPTIONS_DIALOG_16bit].flags=0;

 switch (val){
  case 8: optionsDialog[OPTIONS_DIALOG_8bit].flags=D_SELECTED;break;
  case 15: optionsDialog[OPTIONS_DIALOG_15bit].flags=D_SELECTED;break;
  case 16: optionsDialog[OPTIONS_DIALOG_16bit].flags=D_SELECTED;break;
 }
}

int get_radio_id(int first)
{
 int i=0;
 while (optionsDialog[first+i].flags!=D_SELECTED) i++;
 return i;
}


void change_options()
{
	int new_bpp;

	optionsDialog[OPTIONS_DIALOG_VIEW].d1 = view_num;
	set_dialog_color(optionsDialog, pallete_color[0], pallete_color[15]);
	if (sound_on) optionsDialog[OPTIONS_DIALOG_SOUND].flags = D_SELECTED;
	if (music_on) optionsDialog[OPTIONS_DIALOG_MUSIC].flags = D_SELECTED;
	if (antia_on) optionsDialog[OPTIONS_DIALOG_AA].flags = D_SELECTED;

	if (color_depth > 8) optionsDialog[OPTIONS_DIALOG_GAMMA].flags = 0;
	else optionsDialog[OPTIONS_DIALOG_GAMMA].flags=D_DISABLED;

	optionsDialog[OPTIONS_DIALOG_GAMMA].d2 = gamma_correction;
	optionsDialog[OPTIONS_DIALOG_SOUND_SLIDER].d2 = sound_volume;
	optionsDialog[OPTIONS_DIALOG_MUSIC_SLIDER].d2 = music_volume;
	set_radio_color(color_depth);
  
	optionsRet = do_dialog(optionsDialog, OPTIONS_DIALOG_OK);

	if (optionsRet == OPTIONS_DIALOG_CANCEL) return;

	if (optionsDialog[OPTIONS_DIALOG_MUSIC].flags==D_SELECTED) {
		music_on = true;
		} 
	else {
		music_on = FALSE;
		}
	if (optionsDialog[OPTIONS_DIALOG_SOUND].flags==D_SELECTED) sound_on = true;
	else sound_on=FALSE;

	if (optionsDialog[OPTIONS_DIALOG_AA].flags==D_SELECTED) antia_on=1;
	else antia_on = 0;

	gamma_correction = optionsDialog[OPTIONS_DIALOG_GAMMA].d2;
	new_bpp = get_radio_id(OPTIONS_DIALOG_8bit);
	switch(new_bpp){
		case 0: new_bpp = 8; 
						break;
		case 1: new_bpp = 15; 
						break;
		default: new_bpp = 16;
						break;
		}   
	if (color_depth!=new_bpp) {
		color_depth=new_bpp;
		if (is_mod_playing()!=FALSE) {
			pause_mod();
			init_video();
			resume_mod();
			} 
		else init_video();
		}
	init_gamma();
	
	set_config_file("scp.ini");
	set_config_int("SCP", "BitsPerPixel", color_depth);
	set_config_int("SCP", "Gamma", gamma_correction);
	set_config_int("SCP", "Anti-Aliasing", antia_on);
	set_view(view2number(view_name[optionsDialog[OPTIONS_DIALOG_VIEW].d1]));
	set_config_string("SCP", "View", view_name[optionsDialog[OPTIONS_DIALOG_VIEW].d1]);
	sound_volume = optionsDialog[OPTIONS_DIALOG_SOUND_SLIDER].d2;
	music_volume = optionsDialog[OPTIONS_DIALOG_MUSIC_SLIDER].d2;
	set_config_int("SCP", "SoundVolume", sound_volume);
	set_config_int("SCP", "MusicVolume", music_volume);
	if (compatible_soundcard) {
		set_config_int("SCP", "MusicOn", music_on);
		set_config_int("SCP", "SoundOn", sound_on);
		}
	set_volumes();
	return;
	}

char *numeric_string[] = {"Zero", "One", "Two", "Three", "Four", 
		"Five", "Six", "Seven", "Eight", "Nine", "Ten", "Eleven", 
		"Twelve"};

void edit_fleet(int player) {
	char tmp[40];
  char path[80];
	sprintf (tmp, "Fleet%d", player+1);
	load_fleet("scp.ini", tmp);
	sprintf(fleetPlayer, "Player %s Fleet", numeric_string[player+1]);
	do {
		sprintf(title_str, fleet_title);
		sprintf(fleetTitleString, "%s\n%d points", fleet_title, fleet_cost);

		showTitle();
		fleetRet = do_dialog(fleetDialog, FLEET_DIALOG_SHIPLIST);

		if ((fleetRet == FLEET_DIALOG_SELECT) ||
				(fleetRet == FLEET_DIALOG_SHIPLIST)) {
			select_fleet_slot(
					fleetDialog[FLEET_DIALOG_FLEETLIST].d1,
					fleetDialog[FLEET_DIALOG_SHIPLIST].d1);
			fleetDialog[FLEET_DIALOG_FLEETLIST].d1++;
			}
		if ((fleetRet == FLEET_DIALOG_CLEAR) ||
				(fleetRet == FLEET_DIALOG_FLEETLIST)) {
			clear_fleet_slot(fleetDialog[FLEET_DIALOG_FLEETLIST].d1);
			fleetDialog[FLEET_DIALOG_FLEETLIST].d1++;
			}
		if(fleetRet == FLEET_DIALOG_SAVE) {
			font = desktop_font;
			sprintf(path, "fleets/");
			if(file_select("Save Fleet", path, "scf")) save_fleet(path, "Fleet");
			font = (FONT *)(scppal[SCPPAL_FONT].dat);
			}
		if(fleetRet == FLEET_DIALOG_LOAD) {
			font = desktop_font;
			sprintf(path, "fleets/");
			if(file_select("Load Fleet", path, "scf")) load_fleet(path, "Fleet");
			sprintf(title_str, fleet_title);
			sprintf(fleetTitleString, "%s\n%d points", fleet_title, fleet_cost);
			font = (FONT *)(scppal[SCPPAL_FONT].dat);
			}

		if(fleetRet == FLEET_DIALOG_TITLE) {
			font = desktop_font;
			if(do_dialog(titleDialog, TITLE_DIALOG_BOX) == TITLE_DIALOG_OK)
					sprintf(fleet_title, title_str);
			font = (FONT *)(scppal[SCPPAL_FONT].dat);
			}
		} while((fleetRet != FLEET_DIALOG_MAIN) && (fleetRet != -1));
	save_fleet("scp.ini", tmp);
	}

void change_teams()
{
  set_config_file("scp.ini");
	
	int a;

	showTitle();
	teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1 = 0;
	do {
		dialog_string[0][0] = 0;
		sprintf(dialog_string[0], "Config #%d", 
				player_config[teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1]);

		a = do_dialog(teamsDialog, 0);
		if((a == TEAMS_DIALOG_SELECTCONTROL) || (a == TEAMS_DIALOG_CONTROLLIST)) {
			player_type[teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1] = 
					teamsDialog[TEAMS_DIALOG_CONTROLLIST].d1;
			}
    if ((a == TEAMS_DIALOG_SETUP) || (a == TEAMS_DIALOG_PLAYERLIST)) {
			Control *tmpc = load_player(teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1);
			if (tmpc) {
				showTitle();
				tmpc->setup();
				delete tmpc;
				showTitle();
				}
			}
    if (a == TEAMS_DIALOG_CONFIG_NUM) {
			player_config[teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1] += 1;
			player_config[teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1] %= MAX_CONFIGURATIONS;
			}
    if (a == TEAMS_DIALOG_FLEET) {
			edit_fleet(teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1);
			showTitle();
			}
		} while((a != TEAMS_DIALOG_MAINMENU) && (fleetRet != -1));
  set_config_file("scp.ini");
	for (int i = 0; i < MAX_PLAYERS; i += 1) {
		sprintf(dialog_string[0], "Player%d", i+1);
		set_config_string (dialog_string[0], "Type", control_name[player_type[i]]);
		set_config_int (dialog_string[0], "Config", player_config[i]);
		}
	showTitle();
	return;
	}

char *playerListboxGetter(int index, int *list_size)
{
	static char tmp[80];
	tmp[0] = 0;
  if(index < 0) {
    *list_size = MAX_PLAYERS;
    return NULL;
  } else {
    sprintf(tmp, "Player%d %s %d", index+1, control_name[player_type[index]], player_config[index]);
		ASSERT (strlen(tmp) < 40);
    return tmp;
  }
}
char *controlListboxGetter(int index, int *list_size) 
{
	static char tmp[40];
	tmp[0] = 0;
  if(index < 0) {
    *list_size = num_controls;
    return NULL;
  } else {
    return(control_name[index]);
  }
}
char *viewListboxGetter(int index, int *list_size) 
{
	static char tmp[40];
	tmp[0] = 0;
	if(index < 0) {
		*list_size = num_views;
		return NULL;
	} else {
		return(view_name[index]);
	}
}

void set_volumes() {
	if (compatible_soundcard) {
		if (music_on) set_mod_volume (music_volume);
		else set_mod_volume (0);
		}
	return;
	}