
#include "../melee.h"
#include "../melee/mai.h"
#include <string.h>

//////////////// States of this AI ///////////////
#define AI_CHASE      1
#define AI_EVADE      2
#define AI_ATTACK     3
#define AI_RUNAWAY    4
//////////////////////////////////////////////////
AI_Player_Pkunk::AI_Player_Pkunk(Ship *ai) :
  AI_Player(ai) {

 int tmp_table[20] = {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4};
 memcpy(evade_table, tmp_table, sizeof(int)*20);
 
 select_state = true;
}

void AI_Player_Pkunk::calculate() 
{
 AI_Player::calculate(); //Turn off all 'keys'
 k.fire_special = true;

 if (ai_ship->target==NULL) {
     Stop();
     return;
  }

   switch (state) {
    case AI_CHASE:
                    Chase(ai_ship->target);
                    break;
    case AI_ATTACK:
                    Attack(ai_ship->target);
                    break;

    case AI_RUNAWAY:
                    Runaway(ai_ship->target, 100.0);
                    break;
    default: break;
 } 

CheckShots();

if (select_state) change_state();
}
void AI_Player_Pkunk::ProcessShot(SpaceLocation *shot, double range)
{

 if (range >= 300.0) return;
 if (!isTarget(shot)) return;
 
 if (range <= 200.0){
   switch (evade_table[rand()%20]){
    case   AI_EVADE: 
                     Evade(shot);
                     break;
    case  AI_ATTACK: 
                     Attack(shot);
                     break;
    case AI_RUNAWAY: 
                     Runaway(shot, 100.0);
    }
   select_state = true; 
  }
}

void AI_Player_Pkunk::Attack(SpaceLocation *enemy)
{
  k.fire_weapon = true;


  if (ai_ship->batt <= 2){
    k.turn_left   = false;
    k.turn_right  = false;
    state = AI_RUNAWAY;
  } else {
    k.turn_left   = true;
    k.turn_right  = false;
  }
}

void AI_Player_Pkunk::change_state() 
{

double range = ai_ship->distance(ai_ship->target);

 if (range > 175.0 ) //not max attack range is needed for pkunk type attack
   state = AI_CHASE;
 else 
   state = AI_ATTACK;
  
 select_state = false; 
}
