
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <allegro.h>

#include "../melee.h"
#include "../libs.h"
#include "../scp.h"
#include "../frame.h"

#include "mmain.h"
#include "mview.h"
#include "mcontrol.h"
#include "mcbodies.h"

#define MSECS_PER_TIC				5
#define MSECS_PER_PHYSICS		10
#define MSECS_PER_FPS				100

//#ifdef _WIN32
//   #include <winalleg.h>
//#endif

#include "../melee.h"

#define time_buf_len 4
volatile int total_physics[time_buf_len];
volatile int total_renders[time_buf_len];
volatile int timed_physics[time_buf_len];
volatile int timed_renders[time_buf_len];
volatile int timing_pos = 0;

int game_time;

int play_mode;

int hero;

int num_players;
Control **control;
ShipPanel **panel;

Frame *space;
Frame *radar;

SHIP_INFO ship_info[MAX_SHIP_TYPES];
char     *ship_name[MAX_SHIP_TYPES + 1];
int       num_ship_types;

char *fleet_id[MAX_FLEET_SIZE];
char *fleet_name[MAX_FLEET_SIZE];

char fleet_title[80];
int  fleet_size = 0;
int  fleet_cost = 0;

int debug_value = 0;

char strEmptySlotID[] = "?????";
char strEmptySlotName[] = "[Empty slot]";

DATAFILE *melee;
DATAFILE *scppal;

int melee_paused;

volatile int melee_time;

void melee_timer()
{
	if(!melee_paused)
		melee_time += MSECS_PER_TIC;
}

END_OF_FUNCTION(melee_timer);

void fps_proc()
{
  timing_pos += 1;
  if (timing_pos == time_buf_len) timing_pos = 0;
  total_physics[timing_pos] = 0;
  total_renders[timing_pos] = 0;
  timed_physics[timing_pos] = 0;
  timed_renders[timing_pos] = 0;
}

END_OF_FUNCTION(fps_proc);

char *selectListboxGetter(int index, int *list_size);

#define SELECT_DIALOG_TITLE     0
#define SELECT_DIALOG_LIST      1
#define SELECT_DIALOG_PLAYERBOX 2
#define SELECT_DIALOG_PLAYER    3
#define SELECT_DIALOG_SHIP      4
#define SELECT_DIALOG_RANDOM    5
#define SELECT_DIALOG_ABORT     6

#define VICTORY_DIALOG_TITLE     0
#define VICTORY_DIALOG_LIST      1
#define VICTORY_DIALOG_PLAYERBOX 2
#define VICTORY_DIALOG_PLAYER    3
#define VICTORY_DIALOG_CONTINUE  4

char selectPlayer[18];
char selectTitleString[100];

DIALOG selectDialog[] =
{
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_textbox_proc,    10,   5,    160,  48,   255,  0,    0,    0,       0,    0,    selectTitleString, NULL, NULL },
  { d_list_proc,       10,   60,   160,  415,  255,  0,    0,    D_EXIT,  0,    0,    selectListboxGetter, NULL, NULL },
  { d_box_proc,        240,  5,    160,  20,   255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_ctext_proc,      320,  10,   160,  10,   255,  0,    0,    0,       0,    0,    selectPlayer, NULL, NULL },
  { d_button_proc,     240,  35,   160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Select ship", NULL, NULL },
  { d_button_proc,     240,  95,   160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Random selection", NULL, NULL },
  { d_button_proc,     240,  155,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Abort game", NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

DIALOG victoryDialog[] =
{
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)      (d1)  (d2)  (dp)
  { d_textbox_proc,    10,   5,    160,  48,   255,  0,    0,    0,           0,    0,    selectTitleString,
  NULL, NULL },
  { d_list_proc,       10,   60,   160,  415,  255,  0,    0,    D_DISABLED,  0,    0,    selectListboxGetter,
  NULL, NULL },
  { d_box_proc,        240,  5,    160,  20,   255,  0,    0,    0,           0,    0,    NULL,
  NULL, NULL },
  { d_ctext_proc,      320,  10,   160,  10,   255,  0,    0,    0,           0,    0,    selectPlayer,
  NULL, NULL },
  { d_button_proc,     240,  35,   160,  48,   255,  0,    0,    D_EXIT,      0,    0,    (void *)"Continue",
  NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,           0,    0,    NULL, NULL, NULL }
};

int melee_done;

void       load_ship_data(int index);
void       free_ships(int ship1, int ship2);
ShipPanel *select_ship(int player, int index);
int        ship_idtoindex(char *id_str);

void suspend_melee();
void resume_melee();
int  select_fleet_ship(int player, char *fleet_file, ShipPanel **panel, int fleet_total);
void save_screen_shot();
void show_fleet(int player, char *fleet_file, int fleet_total, int slot);

char  buf[80];
//int   i;
int *total_fleet;
int *slot;
int *ship;
int show_fps = 0;
int antia_on;

void choose_new_ships() {
	int i;
	for (i = 0; i < num_players; i += 1) if ((!panel[i] || !panel[i]->ship) && (slot[i] != -1)) {
		if (panel[i]) delete panel[i];
		panel[i] = NULL;
		char tmp[40];
		sprintf (tmp, "fleet%d.tmp", i+1);
		load_fleet(tmp, "Fleet");
		clear_fleet_slot(slot[i]);
		save_fleet(tmp, "Fleet");
		if ((slot[i] = select_fleet_ship(i, tmp, &panel[i], total_fleet[i])) >= 0)
			ship[i] = ship_idtoindex(fleet_id[slot[i]]);
		if (panel[i] && panel[i]->ship) {
			control[i]->select_ship(panel[i]->ship, ship_info[ship[i]].reg->id);
			for (int t = 0; t < num_players; t += 1) {
				if (t != i) {
					if (panel[t] && panel[t]->ship) control[i]->add_target(panel[t]->ship);
					control[t]->add_target(panel[i]->ship);
					}
				}
			}
		}
	return;
	}


void play_frame() {
  int of = melee_time;
	int i;

  poll_keyboard();
  if (of < MSECS_PER_PHYSICS) return;

	for (i = 0; i < num_players; i += 1) {
    control[i]->calculate();
		}

  spaceFrame->calculate();
  spaceFrame->collide();

	for (i = 0; i < num_players; i += 1) {
    if (panel[i]) panel[i]->calculate();
		}

	view->view();

  timed_physics[timing_pos] += melee_time - of;
  total_physics[timing_pos] += 1;
  melee_time -= MSECS_PER_PHYSICS;
  game_time += MSECS_PER_PHYSICS;
	return;
	}

Stars *stars;

void animate_frame () {
  int of = melee_time;
	int i;
	if (keypressed()) {
		int k = readkey() >> 8;
		switch (k) {
			case KEY_ESC:
			case KEY_F10:
				suspend_melee();
				font = desktop_font;
				if(alert("Game is paused", NULL, NULL, "&Abort game", "&Resume playing", 'a', 'r') == 1)
					melee_done = TRUE;
				font = (FONT *)(scppal[SCPPAL_FONT].dat);
				resume_melee();
				break;
			case KEY_F1:
				suspend_melee();
				font = (FONT *)(scppal[SCPPAL_FONT].dat);
				change_options();
				font = (FONT *)(scppal[SCPPAL_FONT].dat);
				resume_melee();
				break;
			case KEY_F12:
				show_fps = !show_fps;
				break;
			case KEY_F11:
				suspend_melee();
				save_screen_shot();
				resume_melee();
				break;
			}
		}

  radar->erase();
  space->erase();

  stars->animate(space);
  spaceFrame->animate();
	for (i = 0; i < num_players; i += 1) {
		if (panel[i]) panel[i]->animate();
		}
  if(show_fps) {
    int a, b, c, d;
    a = b = 0;
    c = d = 1;
    for (int i = 0; i < time_buf_len; i += 1) if (i != timing_pos) {
      a += timed_physics[i];
      b += timed_renders[i];
      c += total_physics[i];
      d += total_renders[i];
      }
    sprintf(buf, "   physics: %.1f ms  ", double(a) / c);
    textout(space->frame, desktop_font, buf, 0, 0, pallete_color[15]);
    sprintf(buf, "   renders: %.1f ms  ", double(b) / d);
    textout(space->frame, desktop_font, buf, 0, 8, pallete_color[15]);
    sprintf(buf, "   debug: %d ms  ", debug_value);
    textout(space->frame, desktop_font, buf, 0, 16, pallete_color[15]);
    space->add_box(0, 0, 160, 32);
	  }
  radar->draw();
  space->draw();

	if (key[KEY_TILDE]) melee_time += 10;
	timed_renders[timing_pos] += melee_time - of;
	total_renders[timing_pos] += 1;
	return;
	}

void play_melee( int _play_mode, int _num_players, Control **_control)
{
  LOCK_VARIABLE(melee_time);
  LOCK_FUNCTION(melee_timer);

  LOCK_FUNCTION(fps_proc);

  LOCK_VARIABLE(total_physics);
  LOCK_VARIABLE(total_renders);
  LOCK_VARIABLE(timed_physics);
  LOCK_VARIABLE(timed_renders);
  LOCK_VARIABLE(timing_pos);

	int i;
	if (!_num_players) return;

  melee_done = FALSE;
	int planet_num = random() % 3;
  game_time = 0;

  set_config_file("scp.ini");

  for (int tmp = 0; tmp < time_buf_len; tmp += 1) {
    total_physics[tmp] = 0;
    total_renders[tmp] = 0;
    timed_physics[tmp] = 0;
    timed_renders[tmp] = 0;
    }

	play_mode = _play_mode;
	num_players = _num_players;
	control = _control;
	panel = new ShipPanel*[num_players];
	for (i = 0; i < num_players; i += 1) {
		control[i]->initialize();
		panel[i] = NULL;
		}
	total_fleet = new int[num_players];
	slot = new int[num_players];
	ship = new int[num_players];

  switch (play_mode) {
		case 0:
			hero = 0;
			break;
		default:
			tw_error (" That mode of play is not yet supported.");
		}

  set_pallete((RGB*)(scppal[SCPPAL_PALLETE].dat));

  melee = load_datafile("melee.dat");
  if(!melee) tw_error("Error loading melee data\n");

  space = new Frame(0, 0, VIEW_X, VIEW_Y, MAX_SPACE_ITEMS);
  radar = new Frame(SCREEN_W - 60, SCREEN_H - 52, 56, 48, MAX_RADAR_ITEMS);
  stars = new Stars;

  asteroidSprite          = new SpaceSprite(&melee[MELEE_ASTEROID], ASTEROID_FRAMES);
  asteroidExplosionSprite = new SpaceSprite(&melee[MELEE_ASTEROIDEXPLOSION], ASTEROIDEXPLOSION_FRAMES);
  hotspotSprite           = new SpaceSprite(&melee[MELEE_HOTSPOT], HOTSPOT_FRAMES);
  kaboomSprite            = new SpaceSprite(&melee[MELEE_KABOOM], KABOOM_FRAMES);
  sparkSprite             = new SpaceSprite(&melee[MELEE_SPARK], SPARK_FRAMES);

  set_pallete((RGB*)(scppal[planet_num + 1].dat));
  gui_bg_color = pallete_color[0];
  gui_fg_color = pallete_color[15];
  set_dialog_color(selectDialog, pallete_color[0], pallete_color[15]);
  set_dialog_color(victoryDialog, pallete_color[0], pallete_color[15]);
  text_mode(-1);

  font = (FONT *)(scppal[SCPPAL_FONT].dat);

  spacePlanet = new Planet(new SpaceSprite(&melee[MELEE_PLANET + planet_num], 1));
  spaceFrame = new SpaceFrame(space, radar, SPACE_LAYERS);

  spaceFrame->addSpaceObject(spacePlanet);
  spaceFrame->addSpaceObject(new Asteroid());
  spaceFrame->addSpaceObject(new Asteroid());
  spaceFrame->addSpaceObject(new Asteroid());
  spaceFrame->addSpaceObject(new Asteroid());

	set_volumes();
    
  acquire_screen();
  draw_rle_sprite(screen, (RLE_SPRITE *)(melee[MELEE_PANEL].dat),
    SCREEN_W - 64, SCREEN_H - 80);
  release_screen();

  install_keyboard();
  install_mouse();

	for (i = 0; i < num_players; i += 1) {
		char tmp1[40], tmp2[40];
		sprintf (tmp1, "fleet%d.tmp", i+1);
		sprintf (tmp2, "Fleet%d", i+1);
		load_fleet("scp.ini", tmp2);
		save_fleet(tmp1, "Fleet");
		total_fleet[i] = fleet_cost;
		slot[i] = -2;
		ship[i] = -1;
		}
	choose_new_ships();

  resume_melee();

  while(!melee_done) {
    melee_time   = 0;
    melee_paused = FALSE;

    play_mod((JGMOD *)(melee[MELEE_MUSIC].dat), TRUE);

    install_int(melee_timer, MSECS_PER_TIC);
    install_int(fps_proc, MSECS_PER_FPS);

    meleeVictory = NULL;


		int consecutive_nodraws = 0;
    while(!melee_done) {
			bool test = false;
			for (int i = 0; i < num_players; i += 1) {
				if (!panel[i]) test = true;
				else if (!panel[i]->exists()) test = true;
				}
			if (test) break;

			play_frame();

			if (key[KEY_ESC] || (melee_time < MSECS_PER_PHYSICS + 4 * consecutive_nodraws)) {
				animate_frame();
				consecutive_nodraws = 0;
				}
			else consecutive_nodraws += 1;

			}

    stop_mod();

    if(meleeVictory)
      play_mod(meleeVictory, FALSE);

    int start_victory = game_time;

    while((game_time < start_victory + 4200) && !melee_done) {

			play_frame();

			if (key[KEY_ESC] || (melee_time < MSECS_PER_PHYSICS + 4 * consecutive_nodraws)) {
				animate_frame();
				consecutive_nodraws = 0;
				}
			else consecutive_nodraws += 1;

			}

    stop_mod();
    remove_int(melee_timer);
    remove_int(fps_proc);
    suspend_melee();
    while (key[KEY_ENTER] || key[KEY_SPACE]) poll_keyboard();

		choose_new_ships();

//    free_ships(ship1, ship2);

/*		for (i = 0; i < num_players; i += 1) if(panel[i]->ship == NULL) {
			char tmp[40];
			sprintf (tmp, "fleet%d.tmp", i+1);
			load_fleet(tmp, "Fleet");
			if(fleet_size == 0)
					show_fleet(i+1, tmp, total_fleet[i], slot[i]);
			}*/
		resume_melee();
		}

	for (i = 0; i < num_players; i += 1) if(!panel[i] || !panel[i]->ship) {
		char tmp[40];
		sprintf (tmp, "fleet%d.tmp", i+1);
	  control[i]->deinitialize();
	  delete_file(tmp);
		if (panel[i] != NULL) delete panel[i];
		}

  acquire_screen();
  clear(screen);
  release_screen();

  free_ships(-1, -1);

  delete asteroidSprite;
  delete asteroidExplosionSprite;
  delete hotspotSprite;
  delete kaboomSprite;
  delete sparkSprite;
  delete spaceFrame;

  unload_datafile(melee);

	set_volumes();

  remove_keyboard();
  remove_mouse();

  delete radar;
  delete space;
}

void suspend_melee()
{
  gui_bg_color = pallete_color[15];
  gui_fg_color = pallete_color[0];
  melee_paused = TRUE;
}

void resume_melee()
{
	int i;
  text_mode(-1);
  acquire_screen();
  clear_to_color(screen, pallete_color[0]);
  release_screen();
  space->add_box(0, 0, VIEW_X, VIEW_Y);
  radar->add_box(0, 0, 56, 48);
	for (i = 0; i < num_players; i += 1) {
		if ((panel[i]) && (panel[i]->exists())) panel[i]->refresh(i);
		}
  acquire_screen();
  draw_rle_sprite(screen, (RLE_SPRITE *)(melee[MELEE_PANEL].dat),
    SCREEN_W - 64, SCREEN_H - 80);
  release_screen();
  melee_paused = FALSE;
}

int select_fleet_ship(int player, char *fleet_file, ShipPanel **panel,
  int fleet_total)
{
	int ret, slot = 0;
	if (play_mode == 0) {
	  if(((*panel) != NULL) || (melee_done))
		  return(-1);

	  load_fleet(fleet_file, "Fleet");
	  if(fleet_size == 0) {
			char tmp[80];
	    sprintf(tmp, "Player %d Fleet has no ships remaining", player+1);
			if(alert(tmp, NULL, NULL, "&Abort game", "&Resume playing", 'a', 'r') == 1)
					melee_done = TRUE;
			return(-1);
			}

    sprintf(selectPlayer, "Player %d Fleet", player+1);

		sprintf(selectTitleString, "%s\n%d of %d points", fleet_title, fleet_cost, fleet_total);
	  ret = do_dialog(selectDialog, SELECT_DIALOG_LIST);
	  if((ret == SELECT_DIALOG_SHIP) || (ret == SELECT_DIALOG_LIST))
			slot = selectDialog[SELECT_DIALOG_LIST].d1;
		if(ret == SELECT_DIALOG_RANDOM)
	    slot = random() % fleet_size;
	  if((ret == SELECT_DIALOG_ABORT) || (ret == -1)) {
			melee_done = TRUE;
			return(-1);
		}

		(*panel) = select_ship(player, ship_idtoindex(fleet_id[slot]));
		(*panel)->ship->locate();
		spaceFrame->addSpaceObject((*panel)->ship);

		return(slot);
		}
	else {
	  if(((*panel) != NULL) || (melee_done))
		  return(-1);
	  load_fleet(fleet_file, "Fleet");
	  if(fleet_size == 0) {
			melee_done = TRUE;
			return(-1);
			}
		slot = random() % fleet_size;
		(*panel) = select_ship(player, ship_idtoindex(fleet_id[slot]));
		(*panel)->ship->locate();
		spaceFrame->addSpaceObject((*panel)->ship);
    return slot;
		}
}

void save_screen_shot()
{
  static int shot_index = 0;

  BITMAP *bmp;
  PALLETE pal;

  char path[80];

  get_pallete(pal);
  bmp = create_bitmap(SCREEN_W, SCREEN_H);
  acquire_screen();
  blit(screen, bmp, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
  release_screen();

  if(shot_index < 10000) {
    sprintf(path, "scrshots/shot%04d.pcx", shot_index);
    while(exists(path)) {
      shot_index++;
      sprintf(path, "scrshots/shot%04d.pcx", shot_index);
    }
  } else
    sprintf(path, "scrshots/");

  font = desktop_font;
  if(file_select("Save screen shot", path, "BMP;PCX;TGA"))
    save_bitmap(path, bmp, pal);

  destroy_bitmap(bmp);
  font = (FONT *)(scppal[SCPPAL_FONT].dat);
}

void show_fleet(int player, char *fleet_file, int fleet_total, int slot)
{
  load_fleet(fleet_file, "Fleet");

  sprintf(selectPlayer, "Player %d Fleet", player+1);

  sprintf(selectTitleString, "%s\n%d of %d points", fleet_title, fleet_cost, fleet_total);
  victoryDialog[VICTORY_DIALOG_LIST].d1 = slot;
  do_dialog(victoryDialog, VICTORY_DIALOG_CONTINUE);
}

void register_ship(SHIP_REGISTER_INFO *reg_info)
{
  if(num_ship_types >= MAX_SHIP_TYPES)
    return;

  char fn[28];

  fn[0] = '\0';
  strcat(fn, "ships/shp");
  strcat(fn, reg_info->id);
  strcat(fn, ".dat");

  if(!exists(fn))
    return;

  ship_info[num_ship_types].reg = reg_info;
  ship_info[num_ship_types].dat = NULL;

  strcat(fn, "#SHIP_DAT");
  set_config_file(fn);
  ship_info[num_ship_types].cost = get_config_int("Ship", "Cost", 0);

  num_ship_types++;
}

char shipSelection[80];

char *shipListboxGetter(int index, int *list_size)
{
  if(index < 0) {
    *list_size = num_ship_types;
    return NULL;
  } else {
    sprintf(shipSelection, "%s %d", ship_name[index], ship_info[index].cost);
    return shipSelection;
  }
}

void init_fleet()
{
  int i;

  for(i = 0; i < MAX_FLEET_SIZE; i++) {
    fleet_id[i] = strEmptySlotID;
    fleet_name[i] = strEmptySlotName;
  }

  fleet_size = 0;
  fleet_cost = 0;
  sprintf(fleet_title, "Untitled");
}

void select_fleet_slot(int slot, int ship_index)
{
	if (slot < 0) return;
  if(fleet_id[slot] == strEmptySlotID)
    fleet_size++;
  else
    fleet_cost -= ship_info[ship_idtoindex(fleet_id[slot])].cost;

  fleet_cost += ship_info[ship_index].cost;

  fleet_id[slot] = ship_info[ship_index].reg->id;
  fleet_name[slot] = ship_info[ship_index].reg->name;
}

void clear_fleet_slot(int slot)
{
	if (slot < 0) return;
  if(fleet_id[slot] == strEmptySlotID)
    return;

  fleet_cost -= ship_info[ship_idtoindex(fleet_id[slot])].cost;
  fleet_id[slot] = strEmptySlotID;
  fleet_name[slot] = strEmptySlotName;
  fleet_size--;
}

void save_fleet(char *filename, char *section)
{
  int i, count = 0;
  char slot_str[8];

  set_config_file(filename);

  for(i = 0; i < MAX_FLEET_SIZE; i++) {
    if(strcmp(fleet_id[i], strEmptySlotID) != 0) {
      sprintf(slot_str, "Slot%d", count);
      set_config_string(section, slot_str, fleet_id[i]);
      count++;
    }
  }

  for(i = count; i < MAX_FLEET_SIZE; i++) {
    sprintf(slot_str, "Slot%d", i);
    set_config_string(section, slot_str, NULL);
  }

  set_config_int(section, "Size", count);
  set_config_string(section, "Title", fleet_title);

  // to force saved SCF files to be written
  set_config_file("scp.ini");
}

int ship_idtoindex(char *id_str)
{
  int i = 0, found = FALSE;

  #ifdef SCP_DEBUG
  fprintf(debug_file, "- ShipID to index %s\n", id_str);
  fflush(debug_file);
  #endif

  if(id_str == NULL) return -1;

  while((i < num_ship_types) && (!found)) {
    if(strcmp(id_str, ship_info[i].reg->id) == 0)
      found = TRUE;
    else
      i++;
  }

  if(found)
     return(i);
  else
    return(-1);
}

void load_fleet(char *filename, char *section)
{
  int i, count, ship_index;
  char slot_str[8], *slot_id, *title;

  init_fleet();

  set_config_file(filename);
  count = get_config_int(section, "Size", 0);
  title = get_config_string(section, "Title", "");
  sprintf(fleet_title, title);

  for(i = 0; i < count; i++) {
    sprintf(slot_str, "Slot%d", i);
    slot_id = get_config_string(section, slot_str, "?????");
    ship_index = ship_idtoindex(slot_id);
    if(ship_index >= 0)
      select_fleet_slot(i, ship_index);
  }

  fleet_size = count;
}

char *fleetListboxGetter(int index, int *list_size)
{
  if(index < 0) {
    *list_size = MAX_FLEET_SIZE;
    return NULL;
  } else
    return fleet_name[index];
}

char *selectListboxGetter(int index, int *list_size)
{
  if(index < 0) {
    *list_size = fleet_size;
    return NULL;
  } else
    return fleet_name[index];
}

void load_ship_data(int index)
{
  if(ship_info[index].dat != NULL)
    return;

  char fn[19];

  fn[0] = '\0';
  strcat(fn, "ships/shp");
  strcat(fn, ship_info[index].reg->id);
  strcat(fn, ".dat");

  ship_info[index].dat = new ShipData(fn);
}

void init_ships()
{
  int i;

  num_ship_types = 0;

  #include "../ships.h"

  if(num_ship_types == 0) tw_error("No ship data available.\n");

  for(i = 0; i < num_ship_types; i++)
    ship_name[i] = ship_info[i].reg->name;
}

void free_ships(int ship1, int ship2) {
	int i;

	for(i = 0; i < num_ship_types; i++) {
		if((ship_info[i].dat != NULL) && (i != ship1) && (i != ship2)) {
			delete ship_info[i].dat;
			ship_info[i].dat = NULL;
			}
		}
	}

ShipPanel *select_ship(int player, int index) {
	int    radar_color = RADAR_COLOR_FRIEND;
	double angle, x, y;

	if(player != hero) radar_color = RADAR_COLOR_ENEMY;

	x = (double)(random() % (long)(X_MAX));
	y = (double)(random() % (long)(Y_MAX));
	angle = (double)(random() % 64) * 5.625;

	load_ship_data(index);

	char buffy[64];
	buffy[0] = 0;
	strcat (buffy, "ships/");
	strcat (buffy, ship_info[index].reg->id);
	strcat (buffy, ".ini");
	set_config_file (buffy);
  
	return(new ShipPanel(
			ship_info[index].reg->getShip(x, y, angle, player, radar_color,
			ship_info[index].dat, control[player]), player));
	}

int tw_sample (SAMPLE *spl, int vol, int pan, int freq) {
	if (sound_on) 
			return play_sample (spl, (vol * sound_volume) >> 8, pan, freq, false);
	else return 0;
	}
