
#include "../melee.h"

double normalize(double value, double max)
{
  while(value < 0.0)
    value += max;
  while(value > max)
    value -= max;
  return(value);
}

double wcorner(double x, double w)
{
  double value = (x - (w / 2.0) - space_x);

  while(value < (-w))
    value += X_MAX;
  while(value > (X_MAX - w))
    value -= X_MAX;
  value *= space_zoom;

  return(value);
}

double hcorner(double y, double h)
{
  double value = (y - (h / 2.0) - space_y);

  while(value < (-h))
    value += Y_MAX;
  while(value > (Y_MAX - h))
    value -= Y_MAX;
  value *= space_zoom;

  return(value);
}

double min_delta(double from, double to, double max)
{
  double d1 = from - to;
  double d2 = (from + max) - to;
  double d3 = from - (to + max);
  double val = d1;

  if(fabs(val) > fabs(d2)) val = d2;
  if(fabs(val) > fabs(d3)) val = d3;
  return(val);
}

double nearest_coord(double from, double to, double max)
{
  return(from - min_delta(from, to, max));
}

double distance_from(double x, double y, double to_x, double to_y)
{
  double dx = min_delta(x, to_x, X_MAX);
  double dy = min_delta(y, to_y, Y_MAX);

  return(sqrt((dx * dx) + (dy * dy)));
}

void scale_frame_rate(int *value)
{
  *value = (*value + 1) * 5;
}
